$(document).ready(function () {
    clearDocument();
    $("#divNumPadNIT").empty();
    createNumPad("divNumPadNIT", "nit", "K", "", "");

    $('#modalCuenta').modal({
		"inDuration": 0,
		"outDuration": 0
	});
})

function getDocumentoBusqueda() {
    $('#loader').show();
    let serie = $.trim($("#serieInput").val());
    let correlativo = $.trim($("#correlativoInput").val());
    clearDocument();

    if(serie == "" && correlativo == ""){
        $("#divInfoDocumento").slideUp();
        $("#h6Info").show();
        $("#h6Info").html("Ingrese al menos un valor para realizar la busqueda");
        $("#loader").hide();
        return;
    }

    params = {
        service: 'getDocumentoBusqueda',
        dbName: dbName,
        idEmpresas: localStorage.idEmpresas,
        serie: serie,
        correlativo: correlativo
    };

    $.post(host, params, function (data) {
        if(data){
            $("#h6Info").hide();
            $("#divInfoDocumento").slideDown();

            $("#idVenta").val(data[0].id);

            $('#serie').val(data[0].serie);
            $('#numero').val(data[0].correlativo);
            $('#autorizacionFEL').val(data[0].autorizacionFEL);
            $('#fechaEmisionFEL').val(data[0].created_at);
            $('#userName').val(data[0].userName);

            $('#anulacion').val(data[0].estado);
            $('#nitOri').val(data[0].nit);
            $('#direccionOri').val(data[0].direccion);
            $('#nombreOri').val(data[0].nombre);

            $('#subtotal').val(data[0].subtotal);
            $('#descuento').val(data[0].descuento);
            $('#total').val(data[0].valorFactura);

            if(data[0].anulacion == 0){
                $('#btnCambiarNIT').removeClass('disabled');
            }
            else if(!$('#btnCambiarNIT').hasClass('disabled')){
                $('#btnCambiarNIT').addClass('disabled');
            }
        }
        else{
            clearDocument();
            $("#divInfoDocumento").slideUp();
            $("#h6Info").show();
            $("#h6Info").html("No se encontro ningun documento.");
            if(!$('#btnCambiarNIT').hasClass('disabled')){
                $('#btnCambiarNIT').addClass('disabled');
            }
        }
    }, 'json').done(function () {
		$("#loader").hide();
	});

}

function clearDocument(){
    $("#idVenta").val("");
    $('#serie').val("");
    $('#numero').val("");
    $('#autorizacionFEL').val("");
    $('#fechaEmisionFEL').val("");
    $('#userName').val("");
    $('#anulacion').val("");
    $('#nitOri').val("");
    $('#direccionOri').val("");
    $('#nombreOri').val("");
    $('#subtotal').val("");
    $('#descuento').val("");
    $('#total').val("");

    $('#nit').val("");
    $('#direccion').val("");
    $('#nombre').val("");
}

function cambiarNITModal(){
    $("#modalCuenta").modal("open");
}

function consultaNIT() {
	var input = "";
	input = $("#nit").val();

	if (input.replace(/-/g, "") !== "CF") {
		params = {
			service: "consultaNIT",
			dbName: dbName,
			nit: input.replace(/-/g, ""),
			idEmpresas: localStorage.idEmpresas,
			idUsuarios: localStorage.idUsuarios,
			idSucursales: localStorage.idSucursales
		};
		$.post(host, params, function (data) {
			$.each(data, function (key, val) {
				switch (val.message) {
					case "success":
						$("#nombre").val(val.nombre);
						$("#direccion").val(val.direccion);
						break;
					default:
						alert(`${val.msj},\nintente ingresar el nit correctamente`);
						break;
				}
			});
		}, "json").done(function () {
			$("#loader").hide();
		});
	}
}

function anulacionFactura() {
    $("#btnFinalizar").addClass("disabled");
    $("#loader").show();

    let idVenta = $('#idVenta').val();
    let nit = $('#nit').val();
    let nombre = $('#nombre').val();
    let direccion = $('#direccion').val();
    params = {
        service: 'anulacionFactura',
        dbName: dbName,
        idEmpresas: localStorage.idEmpresas,
        idSucursales: localStorage.idSucursales,
        idUsuarios: localStorage.idUsuarios,
        idVenta: idVenta,
        nit: nit,
        nombre: nombre,
        direccion: direccion,
        cambioAFactura: 1,
        motivo: "Cambio de NIT"
    };
    
    $.post(host, params, function (data) {
        $('#btnFinalizar').removeClass('disabled');
        console.log("data", data);
        switch (data[0].message) {
            case 'success':
                Swal.fire({
                    icon: 'success',
                    html: 'Documento anulado con &#233;xito',
                    showConfirmButton: false,
                    timer: 1500
                });

                $("#serieInput").val("");
                $("#correlativoInput").val("");
                $("#modalCuenta").modal("close");
                clearDocument();
                
                printer(data[0].idVenta,1, false, 0);

                break;
            default:
                Swal.fire({
                    icon: 'error',
                    title: `Error al anular documento`,
                    html: data[0].error,
                    showCloseButton: true,
                    confirmButtonText: "Intentar de nuevo",
                });

                break;
        }
    }, 'json').done(function () {
        $("#loader").hide();
    });
};